<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2020 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo
 * Release Date: 2019-01-08
 */
define('IN_DOUCO', true);

require (dirname(__FILE__) . '/include/init.php');

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'default';
 
// 图片上传
include_once (ROOT_PATH . 'include/file.class.php');
$file = new File('images/onepic/'); // 实例化类文件(文件上传路径，结尾加斜杠)
                                                        
// 赋值给模板
$smarty->assign('rec', $rec);
$smarty->assign('cur', 'onepic');
$smarty->assign('ur_here', $_LANG['onepic']);
$smarty->assign('onepic_list', get_onepic_list());

/**
 * +----------------------------------------------------------
 * 图片列表
 * +----------------------------------------------------------
 */
if ($rec == 'default') {
    // CSRF防御令牌生成
    $smarty->assign('token', $token = $firewall->get_token());
 
    // 赋值给模板
    $smarty->assign('btn_lang', $dou->btn_lang('onepic', '', 'name'));
    
    $smarty->display('onepic.htm');
} 

/**
 * +----------------------------------------------------------
 * 图片添加处理
 * +----------------------------------------------------------
 */
elseif ($rec == 'insert') {
    // 验证图片名称
    if (empty($_POST['name'])) $dou->dou_msg($_LANG['onepic_name'] . $_LANG['is_empty']);
    
    // 验证是否上传图片
    if (empty($_FILES['image']['name'])) $dou->dou_msg($_LANG['onepic_image'] . $_LANG['is_empty']);

    // 文件上传盒子
    $image = $file->box('onepic', $dou->auto_id('onepic'), 'image', 'main');

    // 格式化数据
    $add_time = time();

    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);

    $sql = "INSERT INTO " . $dou->table('onepic') . " (id, name, image, add_time, sort)" . " VALUES (NULL, '$_POST[name]', '$image', '$add_time', '$_POST[sort]')";
    $dou->query($sql);
    
    $dou->create_admin_log($_LANG['onepic_add'] . ': ' . $_POST['name']);
    $dou->dou_msg($_LANG['onepic_add_succes'], 'onepic.php');
} 

/**
 * +----------------------------------------------------------
 * 图片编辑
 * +----------------------------------------------------------
 */
elseif ($rec == 'edit') {
    // 验证并获取合法的ID
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : '';
    
    $onepic = $dou->get_row('onepic', '*', "id = '$id'");
    
    // 格式化数据
    $onepic['image'] = $dou->dou_file($onepic['image']);
    
    // CSRF防御令牌生成
    $smarty->assign('token', $token = $firewall->get_token());
    
    // 赋值给模板
    $smarty->assign('onepic', $onepic);
    $smarty->assign('btn_lang', $dou->btn_lang('onepic', $id, 'name'));
    
    $smarty->display('onepic.htm');
} 

elseif ($rec == 'update') {
    // 验证并获取合法的ID
    $id = $check->is_number($_POST['id']) ? $_POST['id'] : '';
    
    // 验证图片名称
    if (empty($_POST['name'])) $dou->dou_msg($_LANG['onepic_name'] . $_LANG['is_empty']);
    
    // 文件上传盒子
    $image = $file->box('onepic', $id, 'image', 'main');
    $image = $image ? ", image = '" . $image . "'" : '';

    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);
    
    $sql = "update " . $dou->table('onepic') . " SET name='$_POST[name]'" . $image . " , sort = '$_POST[sort]' WHERE id = '$id'";
    $dou->query($sql);
    $dou->create_admin_log($_LANG['onepic_edit'] . ': ' . $_POST['name']);
    $dou->dou_msg($_LANG['onepic_edit_succes'], 'onepic.php');
} 

/**
 * +----------------------------------------------------------
 * 图片删除
 * +----------------------------------------------------------
 */
elseif ($rec == 'del') {
    // 验证并获取合法的ID
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : $dou->dou_msg($_LANG['illegal'], 'onepic.php');
    $name = $dou->get_one("SELECT name FROM " . $dou->table('onepic') . " WHERE id = '$id'");
    
    if (isset($_POST['confirm'])) {
        // 删除相应商品图片
        $image = $dou->get_one("SELECT image FROM " . $dou->table('onepic') . " WHERE id = '$id'");
        $dou->del_file($image);
     
        // 删除对应语言项
        if ($_OPEN['language'])
            $dou->del_lang_value('onepic', $id);
        
        $dou->create_admin_log($_LANG['onepic_del'] . ': ' . $name);
        $dou->delete('onepic', "id = $id", 'onepic.php');
    } else {
        $_LANG['del_check'] = preg_replace('/d%/Ums', $name, $_LANG['del_check']);
        $dou->dou_msg($_LANG['del_check'], 'onepic.php', '', '30', "onepic.php?rec=del&id=$id");
    }
}
    
/**
 * +----------------------------------------------------------
 * 获取图片列表
 * +----------------------------------------------------------
 */
function get_onepic_list() {
    $sql = "SELECT * FROM " . $GLOBALS['dou']->table('onepic'). " ORDER BY sort ASC, id ASC";
    $query = $GLOBALS['dou']->query($sql);
    while ($row = $GLOBALS['dou']->fetch_array($query)) {
        $onepic_list[] = array (
                "id" => $row['id'],
                "name" => $row['name'],
                "image" => $GLOBALS['dou']->dou_file($row['image']),
                "add_time" => $row['add_time'],
                "sort" => $row['sort'] 
        );
    }
    
    return $onepic_list;
}
?>